Subject: Re: [Cbor] Does CDDL need to be standards track to be referenced normatively by standards track documents?

From: Jim Schaad <[email-masked]>
Date: Tue, 1 Aug 2017 09:50:31 -0700

>From the state of the draft, I find myself being happy at this point that COSE does not have a normative reference to CDDL at the moment.  Doing so would almost surely result in a problem in trying to take the draft to standard level.  Given the amount of things that seem to pop up in the draft at odd intervals, I almost find myself thinking it should be labeled as experimental since I don't know how much practical usage has gone into them.

I would really like to see the first version of this document published as informational and really soon.  (Like last month.)  And then move the next version to the standards track.  That would give one a fixed version of the document that could potentially be reference as a down ref for the purpose of publishing documents today and potentially moving them to standards level in the future.  We can then have arguments about what features need to be in the document, what it means to specify certain idioms and how to make us all agree what the language means at a partial leisurely pace rather than rushing it through to get Brian's draft (among others) published.

Jim

> -----Original Message-----
> From: CBOR [mailto:[email-masked]] On Behalf Of Brian E Carpenter
> Sent: Friday, July 21, 2017 1:22 PM
> To: Michael Richardson <[email-masked]>; [email-masked]
> Cc: Sean Leonard <[email-masked]>
> Subject: Re: [Cbor] Does CDDL need to be standards track to be referenced
> normatively by standards track documents?
> 
> On 21/07/2017 22:05, Michael Richardson wrote:
> >
> > Between starting this email, and pushing send, I went to find RFC-editor.
> > She happened to be sitting with the AD responsible for GRASP.  Both
> > said that the downref would be permitted only when the use of CDDL was
> > very loose.  Otherwise, it would be a problem.
> 
> Actually that's an IESG decision. But why we'd contort ourselves in that way is
> beyond me.
> 
>      Brian
> 
> >
> > I feel strongly that we need it to be standards track.
> >
> > Sean Leonard <[email-masked]> wrote:
> >     >     It's needed now. The IESG just approved at least one draft that has
> >     > it as a normative reference. How else do you plan to precisely specify
> >     > CBOR message formats?
> >
> >
> >     > “Need” is a very subjective word. It is nice to have. It is better to
> >     > have a stable reference. But “stable references” are also harder to
> >     > make technical changes to as more people rely on it and come up with
> >     > arguments for how things can never change because they already
> >     > wrote/deployed stuff.
> >
> > This doesn't matter for CDDL the way it does for, i.e. IPv6.
> >
> > A specification is going to reference a *SPECIFIC* version of CDDL,
> > and it just fine if we make changes in a new version.  We do need an
> > annotation for the compilers/checkers/, etc. what version they should
> > process, but for the purposes of referencing CDDL, we do not have to
> > worry if it changes afterwards.
> >
> >     > It’s not just the documents that reference this one: it’s also the
> >     > documents that CDDL references. By way of example, CDDL depends on
> >     > regular expressions, and specifically calls out PCRE. PCRE is great but
> >     > is in no way a Standard; it’s a single implementation. There is a lot
> >     > of variation in regular expression engines, and the most useful ones
> >     > (thinking about PCRE, Python, Perl, and .NET) are not SDO
> >     > standards. There are some features in this draft that have not even
> >     > been implemented yet.
> >
> > The lack of a specification for PCRE sounds like a more serious
> > problem regardless of the status we intend for the document.
> >
> >     > For now, you can precisely define your CBOR message format using
> >     > prose. Or you can use some combination of CDDL and prose. Just
> >     > reference CDDL informatively.
> >
> > That just isn't useful.
> > If you tell us to use prose, then our next step will be to write a
> > specification so that we don't have to be so imprecise.
> >
> > --
> > ]               Never tell me the odds!                 | ipv6 mesh networks [
> > ]   Michael Richardson, Sandelman Software Works        | network architect
> [
> > ]     [email-masked]  http://www.sandelman.ca/        |   ruby on rails    [
> >
> >
> >
> >
> >
> >
> > --
> > Michael Richardson <[email-masked]>, Sandelman Software Works
> > -= IPv6 IoT consulting =-
> >
> >
> >
> 
> _______________________________________________
> CBOR mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/cbor